#!/usr/bin/env node
import o from"chalk";import{Command as H}from"commander";import d from"fs";import c from"path";import Q from"prompts";import X from"async-retry";var h={name:"@abstract-foundation/create-abstract-app",version:"0.0.1-beta-3",description:"Create a new Abstract app with AGW setup.",publishConfig:{access:"public"},license:"MIT",repository:{type:"git",url:"https://github.com/abstract-foundation/create-abstract-app-cli"},files:["dist"],keywords:["abstract"],type:"module",exports:"./dist/index.js",bin:"./dist/index.js",scripts:{dev:"tsup --watch",build:"tsup",typecheck:"tsc --noEmit",start:"node dist/index.js","format:write":'prettier --write "**/*.{ts,tsx,mdx}" --cache',"format:check":'prettier --check "**/*.{ts,tsx,mdx}" --cache',release:"changeset version","pub:beta":"pnpm build && pnpm publish --no-git-checks --access public --tag beta","pub:next":"pnpm build && pnpm publish --no-git-checks --access public --tag next","pub:release":"pnpm build && pnpm publish --access public"},dependencies:{"@antfu/ni":"^0.21.4","@babel/core":"^7.22.1","@babel/parser":"^7.22.6","@babel/plugin-transform-typescript":"^7.22.5","async-retry":"^1.3.3",chalk:"5.2.0",commander:"^10.0.0",cosmiconfig:"^8.1.3","cross-spawn":"^7.0.3",diff:"^5.1.0",execa:"^7.0.0","fast-glob":"^3.3.2","fs-extra":"^11.1.0","https-proxy-agent":"^6.2.0","lodash.template":"^4.5.0","node-fetch":"^3.3.0",ora:"^6.1.2",prompts:"^2.4.2",recast:"^0.23.2",tar:"^7.4.3","ts-morph":"^18.0.0","tsconfig-paths":"^4.2.0","validate-npm-package-name":"^6.0.0",zod:"^3.20.2"},devDependencies:{"@types/async-retry":"^1.4.9","@types/babel__core":"^7.20.1","@types/cross-spawn":"^6.0.6","@types/diff":"^5.0.3","@types/fs-extra":"^11.0.1","@types/lodash.template":"^4.5.1","@types/prompts":"^2.4.2","@types/validate-npm-package-name":"^4.0.2",prettier:"^3.3.3",rimraf:"^4.4.1",tsup:"^6.6.3","type-fest":"^3.8.0",typescript:"^4.9.3"},packageManager:"pnpm@9.4.0"};import{extract as R}from"tar";import{Readable as D}from"stream";import{pipeline as F}from"stream/promises";async function O(t){let e=await fetch(t);if(!e.body)throw new Error(`Failed to download: ${t}`);return D.fromWeb(e.body)}async function b(t,e){await F(await O("https://codeload.github.com/Abstract-Foundation/examples/tar.gz/main"),R({cwd:t,strip:2,filter:n=>n.includes(`examples-main/${e}/`)}))}import{execSync as T}from"child_process";import _ from"dns/promises";function W(){if(process.env.https_proxy)return process.env.https_proxy;try{let t=T("npm config get https-proxy",{encoding:"utf8"}).trim();return t!=="null"?t:void 0}catch{return}}async function x(){try{return await _.lookup("registry.yarnpkg.com"),!0}catch{let t=W();if(!t)return!1;try{let{hostname:e}=new URL(t);return await _.lookup(e),!0}catch{return!1}}}import{detect as G}from"@antfu/ni";async function w(t){let e=await G({programmatic:!0,cwd:t});return e==="yarn@berry"?"yarn":e==="pnpm@6"?"pnpm":e==="bun"?"bun":e??"npm"}import L from"cross-spawn";import V from"chalk";async function v(t,e){let n=["install"];return e||(console.log(V.yellow(`You appear to be offline.
Falling back to the local cache.`)),n.push("--offline")),new Promise((r,a)=>{L(t,n,{stdio:"inherit",env:{...process.env,ADBLOCK:"1",NODE_ENV:"development",DISABLE_OPENCOLLECTIVE:"1"}}).on("close",s=>{if(s!==0){a({command:`${t} ${n.join(" ")}`});return}r()})})}import k from"fs";import B from"path";import $ from"chalk";function P(t,e){let n=[".DS_Store",".git",".gitattributes",".gitignore",".gitlab-ci.yml",".hg",".hgcheck",".hgignore",".idea",".npmignore",".travis.yml","LICENSE","Thumbs.db","docs","mkdocs.yml","npm-debug.log","yarn-debug.log","yarn-error.log","yarnrc.yml",".yarn"],r=k.readdirSync(t).filter(a=>!n.includes(a)&&!/\.iml$/.test(a));if(r.length>0){console.log(`The directory ${$.green(e)} contains files that could conflict:`),console.log();for(let a of r)try{k.lstatSync(B.join(t,a)).isDirectory()?console.log(`  ${$.blue(a)}/`):console.log(`  ${a}`)}catch{console.log(`  ${a}`)}return console.log(),console.log("Either try using a new directory name, or remove the files listed above."),console.log(),!1}return!0}import g from"fs";async function E(t){try{return await g.promises.access(t,(g.constants||g).W_OK),!0}catch{return!1}}import{execSync as i}from"child_process";import z from"path";import J from"fs";function K(){try{return i("git rev-parse --is-inside-work-tree",{stdio:"ignore"}),!0}catch{}return!1}function U(){try{return i("hg --cwd . root",{stdio:"ignore"}),!0}catch{}return!1}function Y(){try{return i("git config init.defaultBranch",{stdio:"ignore"}),!0}catch{}return!1}function I(t){let e=!1;try{return i("git --version",{stdio:"ignore"}),K()||U()?!1:(i("git init",{stdio:"ignore"}),e=!0,Y()||i("git checkout -b main",{stdio:"ignore"}),i("git add -A",{stdio:"ignore"}),i('git commit -m "Initial commit from Create Abstract App"',{stdio:"ignore"}),!0)}catch{if(e)try{J.rmSync(z.join(t,".git"),{recursive:!0,force:!0})}catch{}return!1}}import q from"validate-npm-package-name";function S(t){let e=q(t);return e.validForNewPackages?{valid:!0}:{valid:!1,problems:[...e.errors||[],...e.warnings||[]]}}process.on("SIGINT",()=>process.exit(0));process.on("SIGTERM",()=>process.exit(0));async function Z(){console.log(o.green(`
       ===+   +===      
       ====   ====      
        ===  ====               _    _         _                  _   
        +=== ====              / \\  | |__  ___| |_ _ __ __ _  ___| |_ 
        ===   ===             / _ \\ | '_ \\/ __| __| '__/ _\` |/ __| __|
 +========     ========+     / ___ \\| |_) \\__ \\ |_| | | (_| | (__| |_ 
 ========       ========    /_/   \\_\\_.__/|___/\\__|_|  \\__,_|\\___|\\__|
 ====   =========   ====   
      ====== ======     
    ======     ======   
    ====         ====    `));let t=new H().name("create-abstract-app").description("Create a new application with Abstract setup").version(h.version,"-v, --version","display the version number").argument("[project-name]","Name of the project").option("-p, --package-manager <manager>","Package manager to use (npm, yarn, or pnpm)","npm").action(async(e,n)=>{if(!e||e.trim()===""){let p=await Q({type:"text",name:"projectName",message:"What is the name of your project?",validate:C=>{let y=S(c.basename(c.resolve(C)));return y.valid?!0:"Invalid project name: "+y.problems[0]}});p.projectName?e=p.projectName:(console.log(`
Please specify the project directory:
  ${o.cyan(t.name())} ${o.green("<project-directory>")}
For example:
  ${o.cyan(t.name())} ${o.green("my-abstract-app")}

Run ${o.cyan(`${t.name()} --help`)} to see all options.`),process.exit(1))}let r=c.resolve(e);d.existsSync(r)&&!P(r,e)&&(console.log(o.red(`Directory ${e} already exists`)),console.log(o.red("Use a different name or delete the existing directory.")),process.exit(1)),await E(c.dirname(r))||(console.error("The application path is not writable, please check folder permissions and try again."),console.error("It is likely you do not have write permissions for this folder."),process.exit(1)),d.mkdirSync(r,{recursive:!0});let l=await w(process.cwd()),s=n.packageManager||l,f=s==="yarn",M=!f||await x(),A=process.cwd();console.log(o.blue(`Creating a new Abstract app in ${o.green(e)}...`)),process.chdir(r);let j="agw-nextjs";try{await X(()=>b(r,j),{retries:3})}catch(p){console.error("Failed to download and extract example:",p),process.exit(1)}let u=d.existsSync(c.join(r,"package.json"));u&&(console.log(o.blue(`Installing dependencies using ${s}...`)),await v(s,M)),I(r)&&(console.log("Initialized a git repository."),console.log());let m;c.join(A,e)===r?m=e:m=r,console.log(`${o.green("Success!")} Created ${e} at ${r}`),u&&(console.log("Inside that directory, you can run several commands:"),console.log(),console.log("We suggest that you begin by typing:"),console.log(),console.log(o.cyan("  cd"),m),console.log(`  ${o.cyan(`${s} ${f?"":"run "}dev`)}`)),console.log()});t.parse()}Z();export{Z as main};
//# sourceMappingURL=index.js.map